import { a as _objectSpread2, b as _extends } from '../chunk-34722740.js';
import { Box as Box$1 } from 'fannypack/Box';
import 'fannypack/Code';
import 'fannypack/Text';
import { ThemeContext } from 'fannypack/styled';
import { createComponent, createElement, useClassName } from 'fannypack/utils';
import { c as codeTheme, P as Pre, L as Line, T as Token, H as HighlightedCode$1 } from './styles-9e697249.js';
import { useContext, createElement as createElement$1 } from 'react';
import { Box } from 'reakit';
import Highlight, { defaultProps } from 'prism-react-renderer';

function useProps(props) {
  if (props === void 0) {
    props = {};
  }

  var boxProps = Box$1.useProps(props);
  var className = useClassName({
    style: HighlightedCode$1,
    styleProps: props,
    prevClassName: boxProps.className
  });
  return _objectSpread2({}, boxProps, {
    className: className
  });
}

var HighlightedCode = createComponent(function (props) {
  var theme = useContext(ThemeContext);
  var codeTheme$1 = codeTheme(_objectSpread2({
    theme: theme
  }, props));
  var HighlightedCodeProps = useProps(props);
  return createElement({
    children: createElement$1(Highlight, _extends({}, defaultProps, {
      code: props.code // @ts-ignore
      ,
      language: props.language,
      theme: codeTheme$1
    }, props.wrapperProps), function (_ref) {
      var className = _ref.className,
          style = _ref.style,
          tokens = _ref.tokens,
          getLineProps = _ref.getLineProps,
          getTokenProps = _ref.getTokenProps;
      return createElement$1(Pre, _extends({
        isBlock: props.isBlock,
        className: className,
        style: style,
        overrides: props.overrides
      }, props.preProps), tokens.map(function (line, i) {
        return createElement$1(Line, _extends({
          key: i,
          isBlock: props.isBlock
        }, getLineProps({
          line: line,
          key: i
        }), {
          overrides: props.overrides
        }, props.lineProps), line.map(function (token, key) {
          return createElement$1(Token, _extends({
            key: key
          }, getTokenProps({
            token: token,
            key: key
          }), {
            overrides: props.overrides
          }, props.tokenProps));
        }));
      }));
    }),
    component: Box,
    htmlProps: HighlightedCodeProps
  });
}, {
  attach: {
    defaultProps: {
      code: '',
      language: 'javascript',
      preProps: {},
      lineProps: {},
      tokenProps: {},
      wrapperProps: {}
    },
    useProps: useProps
  },
  themeKey: 'HighlightedCode'
});

export { HighlightedCode };
