'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('../chunk-807f135b.js');
var Box = require('fannypack/Box');
require('fannypack/Code');
require('fannypack/Text');
var styled = require('fannypack/styled');
var utils = require('fannypack/utils');
var styles = require('./styles-e147a06f.js');
var React = require('react');
var reakit = require('reakit');
var Highlight = require('prism-react-renderer');
var Highlight__default = _interopDefault(Highlight);

function useProps(props) {
  if (props === void 0) {
    props = {};
  }

  var boxProps = Box.Box.useProps(props);
  var className = utils.useClassName({
    style: styles.HighlightedCode,
    styleProps: props,
    prevClassName: boxProps.className
  });
  return __chunk_1._objectSpread2({}, boxProps, {
    className: className
  });
}

var HighlightedCode = utils.createComponent(function (props) {
  var theme = React.useContext(styled.ThemeContext);
  var codeTheme = styles.codeTheme(__chunk_1._objectSpread2({
    theme: theme
  }, props));
  var HighlightedCodeProps = useProps(props);
  return utils.createElement({
    children: React.createElement(Highlight__default, __chunk_1._extends({}, Highlight.defaultProps, {
      code: props.code // @ts-ignore
      ,
      language: props.language,
      theme: codeTheme
    }, props.wrapperProps), function (_ref) {
      var className = _ref.className,
          style = _ref.style,
          tokens = _ref.tokens,
          getLineProps = _ref.getLineProps,
          getTokenProps = _ref.getTokenProps;
      return React.createElement(styles.Pre, __chunk_1._extends({
        isBlock: props.isBlock,
        className: className,
        style: style,
        overrides: props.overrides
      }, props.preProps), tokens.map(function (line, i) {
        return React.createElement(styles.Line, __chunk_1._extends({
          key: i,
          isBlock: props.isBlock
        }, getLineProps({
          line: line,
          key: i
        }), {
          overrides: props.overrides
        }, props.lineProps), line.map(function (token, key) {
          return React.createElement(styles.Token, __chunk_1._extends({
            key: key
          }, getTokenProps({
            token: token,
            key: key
          }), {
            overrides: props.overrides
          }, props.tokenProps));
        }));
      }));
    }),
    component: reakit.Box,
    htmlProps: HighlightedCodeProps
  });
}, {
  attach: {
    defaultProps: {
      code: '',
      language: 'javascript',
      preProps: {},
      lineProps: {},
      tokenProps: {},
      wrapperProps: {}
    },
    useProps: useProps
  },
  themeKey: 'HighlightedCode'
});

exports.HighlightedCode = HighlightedCode;
