'use strict';

var __chunk_1 = require('../chunk-807f135b.js');
var Box = require('fannypack/Box');
var Code = require('fannypack/Code');
var Text = require('fannypack/Text');
var styled = require('fannypack/styled');
var utils = require('fannypack/utils');

function _templateObject7() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      & {\n        ", ";\n      }\n    "]);

  _templateObject7 = function _templateObject7() {
    return data;
  };

  return data;
}

function _templateObject6() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  ", ";\n\n  & {\n    ", ";\n  };\n"]);

  _templateObject6 = function _templateObject6() {
    return data;
  };

  return data;
}

function _templateObject5() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      display: inline;\n    "]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  ", ";\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      display: inline;\n    "]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  overflow-x: scroll;\n\n  ", ";\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  & {\n    ", ";\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}
var Token = styled.styled(Text.Text)(_templateObject(), utils.theme('HighlightedCode.Token.base'));
var Pre = styled.styled(Code.Code)(_templateObject2(), function (props) {
  return !props.isBlock && styled.css(_templateObject3());
}, utils.theme('HighlightedCode.Pre.base'));
var Line = styled.styled(Box.Box)(_templateObject4(), function (props) {
  return !props.isBlock && styled.css(_templateObject5());
}, utils.theme('HighlightedCode.Line.base'));
var HighlightedCode = function HighlightedCode(styleProps) {
  return styled.cssClass(_templateObject6(), styleProps.isBlock && styled.css(_templateObject7(), utils.theme('HighlightedCode.block')(styleProps)), utils.theme('HighlightedCode.base')(styleProps));
};
var codeTheme = function codeTheme(styleProps) {
  return {
    plain: {
      color: utils.palette('text')(styleProps),
      backgroundColor: utils.palette('white700')(styleProps)
    },
    styles: [{
      types: ['changed'],
      style: {
        color: utils.palette('info')(styleProps)
      }
    }, {
      types: ['deleted'],
      style: {
        color: utils.palette('danger')(styleProps)
      }
    }, {
      types: ['inserted', 'attr-name'],
      style: {
        color: utils.palette('secondary')(styleProps)
      }
    }, {
      types: ['attr-value'],
      style: {
        color: utils.palette('text')(styleProps)
      }
    }, {
      types: ['comment'],
      style: {
        color: utils.palette('gray400')(styleProps)
      }
    }, {
      types: ['builtin', 'char', 'constant', 'url'],
      style: {
        color: utils.palette('secondary')(styleProps)
      }
    }, {
      types: ['string'],
      style: {
        color: utils.palette('text')(styleProps)
      }
    }, {
      types: ['variable'],
      style: {
        color: utils.palette('info')(styleProps)
      }
    }, {
      types: ['number'],
      style: {
        color: utils.palette('info')(styleProps)
      }
    }, {
      // This was manually added after the auto-generation
      // so that punctuations are not italicised
      types: ['punctuation'],
      style: {
        color: utils.palette('primary')(styleProps)
      }
    }, {
      types: ['function', 'selector', 'doctype'],
      style: {
        color: utils.palette('primary')(styleProps)
      }
    }, {
      types: ['class-name'],
      style: {
        color: utils.palette('primary')(styleProps)
      }
    }, {
      types: ['tag'],
      style: {
        color: utils.palette('primary')(styleProps)
      }
    }, {
      types: ['operator', 'property', 'keyword', 'namespace'],
      style: {
        color: utils.palette('primary')(styleProps)
      }
    }, {
      types: ['boolean'],
      style: {
        color: utils.palette('info')(styleProps)
      }
    }]
  };
};

var styles = /*#__PURE__*/Object.freeze({
  Token: Token,
  Pre: Pre,
  Line: Line,
  HighlightedCode: HighlightedCode,
  codeTheme: codeTheme
});

exports.HighlightedCode = HighlightedCode;
exports.Line = Line;
exports.Pre = Pre;
exports.Token = Token;
exports.codeTheme = codeTheme;
exports.styles = styles;
